= How do I add TestNG tests to my project? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

[http://testng.org/doc/index.html TestNG] is a testing framework inspired from JUnit and NUnit but introducing some new functionalities that make it more powerful and easier to use, such as:

== For Maven projects ==
Maven 2 supports TestNG out of the box without the need to download any additional plugins (other than TestNG itself). It is recommended that you use version 2.4 or above of the Surefire plugin (this is the case in all recent versions of Maven).
You can find the full instructions on the [http://maven.apache.org/plugins/maven-surefire-plugin/ Maven Surefire Plugin web site]. There are also [http://maven.apache.org/plugins/maven-surefire-plugin/examples/testng.html TestNG-specific instructions].

==== Specifying your pom.xml ====
The dependency in your project should look like the following:
{{{
#!text/xml
	<dependency>
	  <groupId>org.testng</groupId>
	  <artifactId>testng</artifactId>
	  <version>6.1.1</version>
	  <scope>test</scope>
	</dependency>
}}}
==== Sample Report ====
A sample surefire report with TestNG can be found [http://testng.org/doc/samplereport/index.html here].

== For Ant builds ==
You define the TestNG ant task as follows:
{{{
#!text/xml
	<taskdef resource="testngtasks" classpath="testng.jar"/>
}}}
This task runs TestNG tests and is always run in a forked JVM. Attributes that can be accepted can be found [http://testng.org/doc/ant.html here].

=== More information ===

 * [http://testng.org/doc/maven.html Maven documentation]
 * [http://testng.org/doc/ant.html Ant documentation]


<%= node['trac']['wiki']['footer'] %>